/* split a model mathematically
   written by Dudley J. Benton
*/
#define _CRT_SECURE_NO_DEPRECATE
#include <stdio.h>
#include <float.h>
#define _USE_MATH_DEFINES
#include <math.h>
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include "..\\..\\utilities\\model.h"

MODEL Read3DV(char*fname);
void Write3DV(MODEL*model,char*fname);
MODEL model;

typedef struct{double x,y;}XY;

int InsidePolygon(XY*p,int n,double x,double y)
  {
  int above1,above2,i,right;
  double x1,x2,y1,y2;
  x2=p[n-1].x;
  y2=p[n-1].y;
  above2=y2>y?1:0;
  for(right=i=0;i<n;i++)
    {
    x1=x2;
    y1=y2;
    x2=p[i].x;
    y2=p[i].y;
    above1=above2;
    above2=y2>y?1:0;
    if(above1==above2)
      continue;
    if(x1>x&&x2>x)
      right++;
    else if(y1<y2)
      {
      if((x-x1)*(y2-y1)<(x2-x1)*(y-y1))
        right++;
      }
    else if(y1>y2)
      {
      if((x-x1)*(y2-y1)>(x2-x1)*(y-y1))
        right++;
      }
    }
  return(right&1);
  }

XY poly[]={
  { 0.241,-10.490},
  { 0.948,-12.159},
  { 2.025,-13.213},
  { 3.563,-13.561},
  { 7.295,-13.152},
  { 6.671,-11.892},
  { 5.759,-11.205},
  { 4.265,-10.774},
  { 3.486, -9.338},
  { 3.691, -7.279},
  { 5.288, -5.670},
  { 6.282, -3.360},
  { 6.210, -1.174},
  { 5.657,  0.292},
  { 4.559,  1.265},
  { 3.420,  1.828},
  { 2.206,  2.012},
  { 1.101,  1.495},
  { 0.282,  0.540},
  {-0.189, -1.473},
  {-0.036, -2.971},
  { 0.594, -3.679},
  { 0.903, -5.217},
  { 0.147, -7.000},
  {-0.136, -9.009}};

void Split()
  {
  int e,i,j,k;
  double r,x1,x2,x3,xc,y1,y2,y3,yc,z1,z2,z3,zc;
  model.colors=1;
  for(e=0;e<model.elems;e++)
    {
    i=model.elem[e].i;
    j=model.elem[e].j;
    k=model.elem[e].k;
    x1=model.node[i].x;
    y1=model.node[i].y;
    z1=model.node[i].z;
    x2=model.node[j].x;
    y2=model.node[j].y;
    z2=model.node[j].z;
    x3=model.node[k].x;
    y3=model.node[k].y;
    z3=model.node[k].z;
    xc=(x1+x2+x3)/3.;
    yc=(y1+y2+y3)/3.;
    zc=(z1+z2+z3)/3.;
    r=hypot(xc-19.26,yc-11.26);
//  if(yc>20.-xc)
//  if(r<0.35&&fabs(zc)>1.18)
    if(InsidePolygon(poly,sizeof(poly)/sizeof(poly[0]),xc,yc)&&yc<-zc)
      model.elem[e].color=0xFF0000;
    else
      model.elem[e].color=0x00FF00;
    }
  }

int main(int argc,char**argv,char**envp)
  {
  model=Read3DV("T-Rex.3dv");
  Split();
  Write3DV(&model,"split.3dv");
  return(0);
  }
