#define _CRT_SECURE_NO_DEPRECATE
#include <stdio.h>
#include <float.h>
#define _USE_MATH_DEFINES
#include <math.h>

typedef struct{double x,y,z;}VECTOR;

int main(int argc,char**argv,char**envp)
  {
  char fname[]="coil.p3d";
  int i,j,m=20,n=51;
  double a,c,dxdt,dydt,dzdt,phi,r,R,s,t,theta,x,y,z;
  VECTOR u,v;
  FILE*fp;
  printf("creating 3d wireframe: %s\n",fname);
  if((fp=fopen(fname,"wt"))==NULL)
    return(__LINE__);
  fprintf(fp,"POLY red\n");
  R=1.;
  for(i=0;i<n;i++)
    {
    t=i*2.5/(n-1.);
    x=R*cos(t*2.*M_PI);
    y=R*sin(t*2.*M_PI);
    z=pow(t,1.5);
    fprintf(fp,"%lG %lG %lG\n",x,y,z);
    R*=0.975;
    }
  fprintf(fp,"END\n");
  R=1.;
  r=0.1;
  for(i=0;i<n;i++)
    {
    t=i*2.5/(n-1.);
    x=R*cos(t*2.*M_PI);
    y=R*sin(t*2.*M_PI);
    z=pow(t,1.5);
    dxdt=-2.*M_PI*R*sin(t*2.*M_PI);
    dydt=2.*M_PI*R*cos(t*2.*M_PI);
    dzdt=1.5*pow(t,0.5);
    theta=-atan2(dydt,dxdt);
    phi=atan2(hypot(dxdt,dydt),dzdt);
    u.x=sin(theta);
    u.y=cos(theta);
    u.z=0.;
    if(fabs(cos(theta))>fabs(sin(theta)))
      v.z=dxdt/cos(theta);
    else
      v.z=-dydt/sin(theta);
    v.x=-dzdt*cos(theta);
    v.y=dzdt*sin(theta);
    a=sqrt(v.x*v.x+v.y*v.y+v.z*v.z);
    v.x/=a;
    v.y/=a;
    v.z/=a;
    fprintf(fp,"POLY red\n");
    for(j=0;j<=m;j++)
      {
      c=cos(j*2.*M_PI/m);
      s=sin(j*2.*M_PI/m);
      fprintf(fp,"%lG %lG %lG\n",
        x+r*(s*u.x+c*v.x),
        y+r*(s*u.y+c*v.y),
        z+r*(s*u.z+c*v.z));
      }
    fprintf(fp,"END\n");
    r*=0.975;
    R*=0.975;
    }
  for(j=0;j<=m;j++)
    {
    c=cos(j*2.*M_PI/m);
    s=sin(j*2.*M_PI/m);
    fprintf(fp,"POLY blue\n");
    R=1.;
    r=0.1;
    for(i=0;i<n;i++)
      {
      t=i*2.5/(n-1.);
      x=R*cos(t*2.*M_PI);
      y=R*sin(t*2.*M_PI);
      z=pow(t,1.5);
      dxdt=-2.*M_PI*R*sin(t*2.*M_PI);
      dydt=2.*M_PI*R*cos(t*2.*M_PI);
      dzdt=1.5*pow(t,0.5);
      theta=-atan2(dydt,dxdt);
      phi=atan2(hypot(dxdt,dydt),dzdt);
      u.x=sin(theta);
      u.y=cos(theta);
      u.z=0.;
      if(fabs(cos(theta))>fabs(sin(theta)))
        v.z=dxdt/cos(theta);
      else
        v.z=-dydt/sin(theta);
      v.x=-dzdt*cos(theta);
      v.y=dzdt*sin(theta);
      a=sqrt(v.x*v.x+v.y*v.y+v.z*v.z);
      v.x/=a;
      v.y/=a;
      v.z/=a;
      fprintf(fp,"%lG %lG %lG\n",
        x+r*(s*u.x+c*v.x),
        y+r*(s*u.y+c*v.y),
        z+r*(s*u.z+c*v.z));
      r*=0.975;
      R*=0.975;
      }
    fprintf(fp,"END\n");
    }
  fclose(fp);
  return(0);
  }
  