/* read a TP2 3D View file and write out a
   Virtual Reality Markup Language (VRML or WRL) file
   written by Dudley J. Benton
*/
#define _CRT_SECURE_NO_DEPRECATE
#include <stdio.h>
#include <io.h>
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include "model.h"

MODEL Read3DV(char*fname);
void WriteWRL(MODEL*model,char*fname);

int main(int argc,char**argv,char**envp)
  {
  char*try="... try\n3DVtoWRL infile.3dv\n";
  char fname[FILENAME_MAX],*ptr;
  MODEL model;
  printf("read 3DV write WRL (VRML)\n");
  if(argc<2)
    {
    printf("no input file specified%s",try);
    return(__LINE__);
    }
  if(argc>2)
    {
    printf("too many arguments%s",try);
    return(__LINE__);
    }
  printf("input file: %s\n",argv[1]);
  strcpy(fname,argv[1]);
  if((ptr=strstr(fname,".3dv"))==NULL)
    {
    printf("input file must have extension 3DV%s",try);
    return(__LINE__);
    }
  strcpy(ptr,".wrl");
  model=Read3DV(argv[1]);
  printf("%i nodes\n",model.nodes);
  if(model.nodes<3)
    Abort(__LINE__,"can't read input file");
  printf("%i elements\n",model.elems);
  printf("output file: %s\n",fname);
  if(!_access(fname,0))
    {
    printf("output file must not already exist\n");
    return(__LINE__);
    }
  WriteWRL(&model,fname);
  return(0);
  }
