#define _3DS_NULL_CHUNK             0x0000
#define _3DS_UNKNOWN                0x0001  /* float */
#define _3DS_M3D_VERSION            0x0002  /* short (Version) */
#define _3DS_M3D_KFVERSION          0x0005
#define _3DS_COLOR_F                0x0010  /* float r,g,b (Floating-point color description) */
#define _3DS_COLOR_24               0x0011  /* BYTE r,g,b (24-bit color description) */
#define _3DS_LIN_COLOR_24           0x0012  /* BYTE r,g,b (24-bit color description) */
#define _3DS_LIN_COLOR_F            0x0013  /* float r,g,b (Floating-point color description) */
#define _3DS_INT_PERCENTAGE         0x0030  /* short (Percentage value) */
#define _3DS_FLOAT_PERCENTAGE       0x0031  /* float (Percentage value) */
#define _3DS_MASTER_SCALE           0x0100  /* float (Scale factor) */
#define _3DS_CHUNKTYPE              0x0995
#define _3DS_CHUNKUNIQUE            0x0996
#define _3DS_NOTCHUNK               0x0997
#define _3DS_CONTAINER              0x0998
#define _3DS_ISCHUNK                0x0999
#define _3DS_C_SXP_SELFI_MASKDATA   0x0C3C
#define _3DS_BIT_MAP                0x1100  /* char[] (0-terminated ASCII string) */
#define _3DS_USE_BIT_MAP            0x1101
#define _3DS_SOLID_BGND             0x1200  /* float r,g,b */
#define _3DS_USE_SOLID_BGND         0x1201
#define _3DS_V_GRADIENT             0x1300  /* float (Midpoint of gradient) */
#define _3DS_USE_V_GRADIENT         0x1301
#define _3DS_LO_SHADOW_BIAS         0x1400  /* float (Bias) */
#define _3DS_HI_SHADOW_BIAS         0x1410
#define _3DS_SHADOW_MAP_SIZE        0x1420  /* short (Size) */
#define _3DS_SHADOW_SAMPLES         0x1430
#define _3DS_SHADOW_RANGE           0x1430
#define _3DS_SHADOW_FILTER          0x1430  /* float (Filter) */
#define _3DS_RAY_BIAS               0x1460  /* float (Bias) */
#define _3DS_O_CONSTS               0x1500  /* float x,y,z (Plane values) */
#define _3DS_AMBIENT_LIGHT          0x2100
#define _3DS_FOG                    0x2200  /* float[4] (near_plane, near_density, far_plane, far_density) */
#define _3DS_USE_FOG                0x2201
#define _3DS_FOG_BGND               0x2210
#define _3DS_DISTANCE_CUE           0x2300  /* float[4] (near_plane, near_density, far_plane, far_density) */
#define _3DS_USE_DISTANCE_CUE       0x2301
#define _3DS_LAYER_FOG              0x2302  /* float[3] (fog_z_from, fog_z_to, fog_density) */
#define _3DS_USE_LAYER_FOG          0x2303
#define _3DS_DCUE_BGND              0x2310
#define _3DS_SMAGIC                 0x2D2D
#define _3DS_LMAGIC                 0x2D3D
#define _3DS_DEFAULT_VIEW           0x3000
#define _3DS_VIEW_TOP               0x3010  /* float[4] (target_x, target_y, target_z, view_width) */
#define _3DS_VIEW_BOTTOM            0x3020  /* float[4] (target_x, target_y, target_z, view_width) */
#define _3DS_VIEW_LEFT              0x3030  /* float[4] (target_x, target_y, target_z, view_width) */
#define _3DS_VIEW_RIGHT             0x3040  /* float[4] (target_x, target_y, target_z, view_width) */
#define _3DS_VIEW_FRONT             0x3050  /* float[4] (target_x, target_y, target_z, view_width) */
#define _3DS_VIEW_BACK              0x3060  /* float[4] (target_x, target_y, target_z, view_width) */
#define _3DS_VIEW_USER              0x3070  /* float[4] (target_x, target_y, target_z, view_width) */
#define _3DS_VIEW_CAMERA            0x3080  /* char[] (0-terminated ASCII string) */
#define _3DS_VIEW_WINDOW            0x3090
#define _3DS_MDATA                  0x3D3D  /* WORD (Mesh data magic number 4D4D) */
#define _3DS_MESH_VERSION           0x3D3E
#define _3DS_MLIBMAGIC              0x3DAA  /* WORD (Material library magic number) */
#define _3DS_PRJMAGIC               0x3DC2  /* WORD (Project number magic number) */
#define _3DS_MATMAGIC               0x3DFF  /* WORD (Material file magic number) */
#define _3DS_NAMED_OBJECT           0x4000  /* char[] (0-terminated ASCII string) */
#define _3DS_OBJ_HIDDEN             0x4010
#define _3DS_OBJ_VIS_LOFTER         0x4011
#define _3DS_OBJ_DOESNT_CAST        0x4012
#define _3DS_OBJ_MATTE              0x4013
#define _3DS_OBJ_FAST               0x4014
#define _3DS_OBJ_PROCEDURAL         0x4015
#define _3DS_OBJ_FROZEN             0x4016
#define _3DS_OBJ_DONT_RCVSHADOW     0x4017
#define _3DS_N_TRI_OBJECT           0x4100  /* na (Named triangle object) */
#define _3DS_POINT_ARRAY            0x4110  /* short (Number of points) */
#define _3DS_POINT_FLAG_ARRAY       0x4111  /* short (Number of flags) */
#define _3DS_FACE_ARRAY             0x4120  /* short (Number of faces) */
#define _3DS_MSH_MAT_GROUP          0x4130  /* char[] (Material name) */
#define _3DS_TEX_VERTS              0x4140  /* short (Number of vertices) */
#define _3DS_SMOOTH_GROUP           0x4150  /* short[] (Groups = faces x 4) */
#define _3DS_MESH_MATRIX            0x4160  /* float[4][3] (4x3 FLOAT matrix) */
#define _3DS_MESH_TEXTURE_INFO      0x4170  /* short (map_type) */
#define _3DS_PROC_NAME              0x4181
#define _3DS_PROC_DATA              0x4182
#define _3DS_MSH_BOXMAP             0x4190
#define _3DS_N_D_L_OLD              0x4400
#define _3DS_N_CAM_OLD              0x4500
#define _3DS_N_DIRECT_LIGHT         0x4600  /* float[3] (x,y,z of light) */
#define _3DS_DL_SPOTLIGHT           0x4610  /* float[5] (target_x, target_y, target_z, hotspot_ang, falloff_ang) */
#define _3DS_DL_OFF                 0x4620
#define _3DS_DL_ATTENUATE           0x4625
#define _3DS_DL_RAYSHAD             0x4627
#define _3DS_DL_SHADOWED            0x4630
#define _3DS_DL_LOCAL_SHADOW        0x4640
#define _3DS_DL_LOCAL_SHADOW2       0x4641
#define _3DS_DL_SEE_CONE            0x4650
#define _3DS_DL_SPOT_RECTANGULAR    0x4651
#define _3DS_DL_SPOT_OVERSHOOT      0x4652
#define _3DS_DL_SPOT_PROJECTOR      0x4653
#define _3DS_DL_EXCLUDE             0x4654
#define _3DS_DL_RANGE               0x4655
#define _3DS_DL_SPOT_ROLL           0x4656  /* float (Roll angle) */
#define _3DS_DL_SPOT_ASPECT         0x4657
#define _3DS_DL_RAY_BIAS            0x4658  /* float (Bias) */
#define _3DS_DL_INNER_RANGE         0x4659  /* float (Range) */
#define _3DS_DL_OUTER_RANGE         0x465A  /* float (Range) */
#define _3DS_DL_MULTIPLIER          0x465B  /* float (Multiplier value) */
#define _3DS_N_AMBIENT_LIGHT        0x4680
#define _3DS_N_CAMERA               0x4700  /* float[3] (camera_x, camera_y, camera_z) */
#define _3DS_CAM_SEE_CONE           0x4710
#define _3DS_CAM_RANGES             0x4720  /* float[2] (near_range, far_range) */
#define _3DS_M3DMAGIC               0x4D4D  /* na (3DS file magic number) */
#define _3DS_HIERARCHY              0x4F00
#define _3DS_PARENT_OBJECT          0x4F10
#define _3DS_PIVOT_OBJECT           0x4F20
#define _3DS_PIVOT_LIMITS           0x4F30
#define _3DS_PIVOT_ORDER            0x4F40
#define _3DS_XLATE_RANGE            0x4F50
#define _3DS_POLY_2D                0x5000
#define _3DS_SHAPE_OK               0x5010
#define _3DS_SHAPE_NOT_OK           0x5011
#define _3DS_SHAPE_HOOK             0x5020
#define _3DS_PATH_3D                0x6000
#define _3DS_PATH_MATRIX            0x6005
#define _3DS_SHAPE_2D               0x6010
#define _3DS_M_SCALE                0x6020
#define _3DS_M_TWIST                0x6030
#define _3DS_M_TEETER               0x6040
#define _3DS_M_FIT                  0x6050
#define _3DS_M_BEVEL                0x6060
#define _3DS_XZ_CURVE               0x6070
#define _3DS_YZ_CURVE               0x6080
#define _3DS_INTERPCT               0x6090
#define _3DS_DEFORM_LIMIT           0x60A0
#define _3DS_USE_CONTOUR            0x6100
#define _3DS_USE_TWEEN              0x6110
#define _3DS_USE_SCALE              0x6120
#define _3DS_USE_TWIST              0x6130
#define _3DS_USE_TEETER             0x6140
#define _3DS_USE_FIT                0x6150
#define _3DS_USE_BEVEL              0x6160
#define _3DS_VIEWPORT_LAYOUT_OLD    0x7000
#define _3DS_VIEWPORT_LAYOUT        0x7001  /* short[7] (form, top, ready, wstate, swapws, swapport, swapcur) */
#define _3DS_VIEWPORT_DATA_OLD      0x7010
#define _3DS_VIEWPORT_DATA          0x7011  /* short[7] (flags, axis_lockout, win_x, win_y, win_w, win_h, win_view) */
#define _3DS_VIEWPORT_DATA_3        0x7011  /* short[7] (flags, axis_lockout, win_x, win_y, win_w, win_h, win_view) */
#define _3DS_VIEWPORT_SIZE          0x7020  /* short[4] (x,y,width,height) */
#define _3DS_NETWORK_VIEW           0x7030
#define _3DS_XDATA_SECTION          0x8000
#define _3DS_XDATA_ENTRY            0x8001
#define _3DS_XDATA_APPNAME          0x8002
#define _3DS_XDATA_STRING           0x8003
#define _3DS_XDATA_FLOAT            0x8004
#define _3DS_XDATA_DOUBLE           0x8005
#define _3DS_XDATA_SHORT            0x8006
#define _3DS_XDATA_LONG             0x8007
#define _3DS_XDATA_VOID             0x8008
#define _3DS_XDATA_GROUP            0x8009
#define _3DS_XDATA_RFU6             0x800A
#define _3DS_XDATA_RFU5             0x800B
#define _3DS_XDATA_RFU4             0x800C
#define _3DS_XDATA_RFU3             0x800D
#define _3DS_XDATA_RFU2             0x800E
#define _3DS_XDATA_RFU1             0x800F
#define _3DS_PARENT_NAME            0x80F0
#define _3DS_MAT_NAME               0xA000  /* char[] (0-terminated ASCII string--material name) */
#define _3DS_MAT_AMBIENT            0xA010
#define _3DS_MAT_DIFFUSE            0xA020
#define _3DS_MAT_SPECULAR           0xA030
#define _3DS_MAT_SHININESS          0xA040
#define _3DS_MAT_SHIN2PCT           0xA041
#define _3DS_MAT_SHIN3PCT           0xA042
#define _3DS_MAT_TRANSPARENCY       0xA050
#define _3DS_MAT_XPFALL             0xA052
#define _3DS_MAT_REFBLUR            0xA053
#define _3DS_MAT_SELF_ILLUM         0xA080
#define _3DS_MAT_TWO_SIDE           0xA081
#define _3DS_MAT_DECAL              0xA082
#define _3DS_MAT_ADDITIVE           0xA083
#define _3DS_MAT_SELF_ILPCT         0xA084
#define _3DS_MAT_WIRE               0xA085
#define _3DS_MAT_SUPERSMP           0xA086
#define _3DS_MAT_WIRESIZE           0xA087  /* float (Wire size) */
#define _3DS_MAT_FACEMAP            0xA088
#define _3DS_MAT_XPFALLIN           0xA08A
#define _3DS_MAT_PHONGSOFT          0xA08C
#define _3DS_MAT_WIREABS            0xA08E
#define _3DS_MAT_SHADING            0xA100  /* short (Shading value) */
#define _3DS_MAT_TEXMAP             0xA200
#define _3DS_MAT_SPECMAP            0xA204
#define _3DS_MAT_OPACMAP            0xA210
#define _3DS_MAT_REFLMAP            0xA220
#define _3DS_MAT_BUMPMAP            0xA230
#define _3DS_MAT_USE_XPFALL         0xA240
#define _3DS_MAT_USE_REFBLUR        0xA250
#define _3DS_MAT_BUMP_PERCENT       0xA252
#define _3DS_MAT_MAPNAME            0xA300  /* char[] (0-terminated ASCII filename) */
#define _3DS_MAT_ACUBIC             0xA310
#define _3DS_MAT_SXP_TEXT_DATA      0xA320
#define _3DS_MAT_SXP_TEXT2_DATA     0xA321
#define _3DS_MAT_SXP_OPAC_DATA      0xA322
#define _3DS_MAT_SXP_BUMP_DATA      0xA324
#define _3DS_MAT_SXP_SPEC_DATA      0xA325
#define _3DS_MAT_SXP_SHIN_DATA      0xA326
#define _3DS_MAT_SXP_SELF1_DATA     0xA328
#define _3DS_MAT_SXP_TEXT2_MASKDATA 0xA32C
#define _3DS_MAT_SXP_OPAC_MASKDATA  0xA32E
#define _3DS_MAT_SXP_BUMP_MASKDATA  0xA330
#define _3DS_MAT_SXP_SPEC_MASKDATA  0xA332
#define _3DS_MAT_SXP_SHIN_MASKDATA  0xA334
#define _3DS_MAT_SXP_SELF1_MASKDATA 0xA336
#define _3DS_MAT_SXP_REFL_MASKDATA  0xA338
#define _3DS_MAT_TEX2MAP            0xA33A
#define _3DS_MAT_SHINMAP            0xA33C
#define _3DS_MAT_SELFIMAP           0xA33D
#define _3DS_MAT_TEXMASK            0xA33E
#define _3DS_MAT_TEX2MASK           0xA340
#define _3DS_MAT_OPACMASK           0xA342
#define _3DS_MAT_BUMPMASK           0xA344
#define _3DS_MAT_SHINMASK           0xA346
#define _3DS_MAT_SPECMASK           0xA348
#define _3DS_MAT_SELFIMASK          0xA34A
#define _3DS_MAT_REFLMASK           0xA34C
#define _3DS_MAT_MAP_TILINGOLD      0xA350
#define _3DS_MAT_MAP_TILING         0xA351  /* short (Flags) */
#define _3DS_MAT_MAP_TEXBLUR_OLD    0xA352
#define _3DS_MAT_MAP_TEXBLUR        0xA353  /* float (Blurring value) */
#define _3DS_MAT_MAP_USCALE         0xA354
#define _3DS_MAT_MAP_VSCALE         0xA356
#define _3DS_MAT_MAP_UOFFSET        0xA358
#define _3DS_MAT_MAP_VOFFSET        0xA35A
#define _3DS_MAT_MAP_ANG            0xA35C
#define _3DS_MAT_MAP_COL1           0xA360
#define _3DS_MAT_MAP_COL2           0xA362
#define _3DS_MAT_MAP_RCOL           0xA364
#define _3DS_MAT_MAP_GCOL           0xA366
#define _3DS_MAT_MAP_BCOL           0xA368
#define _3DS_MAP_ENTRY              0xAFFF
#define _3DS_KFDATA                 0xB000
#define _3DS_AMBIENT_NODE_TAG       0xB001
#define _3DS_OBJECT_NODE_TAG        0xB002
#define _3DS_CAMERA_NODE_TAG        0xB003
#define _3DS_TARGET_NODE_TAG        0xB004
#define _3DS_LIGHT_NODE_TAG         0xB005
#define _3DS_L_TARGET_NODE_TAG      0xB006
#define _3DS_SPOTLIGHT_NODE_TAG     0xB007
#define _3DS_KFSEG                  0xB008  /* short[2] (start, end) */
#define _3DS_KFCURTIME              0xB009  /* short (curframe) */
#define _3DS_KFHDR                  0xB00A  /* short (Revision number) */
#define _3DS_NODE_HDR               0xB010  /* char[] (0-terminated ASCII object name) */
#define _3DS_INSTANCE_NAME          0xB011
#define _3DS_PRESCALE               0xB012
#define _3DS_PIVOT                  0xB013  /* float[3] (pivot_x, pivot_y, pivot_z) */
#define _3DS_BOUNDBOX               0xB014
#define _3DS_MORPH_SMOOTH           0xB015  /* float (Smoothing angle (radians)) */
#define _3DS_POS_TRACK_TAG          0xB020  /* short (Flags) */
#define _3DS_ROT_TRACK_TAG          0xB021  /* short (Flags) */
#define _3DS_SCL_TRACK_TAG          0xB022  /* short (Flags) */
#define _3DS_FOV_TRACK_TAG          0xB023  /* short (Flags) */
#define _3DS_ROLL_TRACK_TAG         0xB024  /* short (Flags) */
#define _3DS_COL_TRACK_TAG          0xB025  /* short (Flags) */
#define _3DS_MORPH_TRACK_TAG        0xB026  /* short (Flags) */
#define _3DS_HOT_TRACK_TAG          0xB027  /* short (Flags) */
#define _3DS_FALL_TRACK_TAG         0xB028  /* short (Flags) */
#define _3DS_HIDE_TRACK_TAG         0xB029
#define _3DS_NODE_ID                0xB030  /* short (ID value) */
#define _3DS_C_MDRAWER              0xC010
#define _3DS_C_TDRAWER              0xC020
#define _3DS_C_SHPDRAWER            0xC030
#define _3DS_C_MODDRAWER            0xC040
#define _3DS_C_RIPDRAWER            0xC050
#define _3DS_C_TXDDRAWER            0xC060
#define _3DS_C_PDRAWER              0xC062
#define _3DS_C_MTLDRAWER            0xC064
#define _3DS_C_FLIDRAWER            0xC066
#define _3DS_C_CUBDRAWER            0xC067
#define _3DS_C_MFILE                0xC070
#define _3DS_C_SHPFILE              0xC080
#define _3DS_C_MODFILE              0xC090
#define _3DS_C_RIPFILE              0xC0A0
#define _3DS_C_TXFILE               0xC0B0
#define _3DS_C_PFILE                0xC0B2
#define _3DS_C_MTLFILE              0xC0B4
#define _3DS_C_FLIFILE              0xC0B6
#define _3DS_C_PALFILE              0xC0B8
#define _3DS_C_TX_STRING            0xC0C0
#define _3DS_C_CONSTS               0xC0D0
#define _3DS_C_SNAPS                0xC0E0
#define _3DS_C_GRIDS                0xC0F0
#define _3DS_C_ASNAPS               0xC100
#define _3DS_C_GRID_RANGE           0xC110
#define _3DS_C_RENDTYPE             0xC120
#define _3DS_C_PROGMODE             0xC130
#define _3DS_C_PREVMODE             0xC140
#define _3DS_C_MODWMODE             0xC150
#define _3DS_C_MODMODEL             0xC160
#define _3DS_C_ALL_LINES            0xC170
#define _3DS_C_BACK_TYPE            0xC180
#define _3DS_C_MD_CS                0xC190
#define _3DS_C_MD_CE                0xC1A0
#define _3DS_C_MD_SML               0xC1B0
#define _3DS_C_MD_SMW               0xC1C0
#define _3DS_C_LOFT_WITH_TEXTURE    0xC1C3
#define _3DS_C_LOFT_L_REPEAT        0xC1C4
#define _3DS_C_LOFT_W_REPEAT        0xC1C5
#define _3DS_C_LOFT_UV_NORMALIZE    0xC1C6
#define _3DS_C_WELD_LOFT            0xC1C7
#define _3DS_C_MD_PDET              0xC1D0
#define _3DS_C_MD_SDET              0xC1E0
#define _3DS_C_RGB_MODE             0xC1F0
#define _3DS_C_RGB_HIDE             0xC200
#define _3DS_C_RGB_MAPSW            0xC202
#define _3DS_C_RGB_TWOSIDE          0xC204
#define _3DS_C_RGB_SHADOW           0xC208
#define _3DS_C_RGB_AA               0xC210
#define _3DS_C_RGB_OVW              0xC220
#define _3DS_C_RGB_OVH              0xC230
#define _3DS_CMAGIC                 0xC23D
#define _3DS_C_RGB_PICTYPE          0xC240
#define _3DS_C_RGB_OUTPUT           0xC250
#define _3DS_C_RGB_TODISK           0xC253
#define _3DS_C_RGB_COMPRESS         0xC254
#define _3DS_C_JPEG_COMPRESSION     0xC255
#define _3DS_C_RGB_DISPDEV          0xC256
#define _3DS_C_RGB_HARDDEV          0xC259
#define _3DS_C_RGB_PATH             0xC25A
#define _3DS_C_BITMAP_DRAWER        0xC25B
#define _3DS_C_RGB_FILE             0xC260
#define _3DS_C_RGB_OVASPECT         0xC270
#define _3DS_C_RGB_ANIMTYPE         0xC271
#define _3DS_C_RENDER_ALL           0xC272
#define _3DS_C_REND_FROM            0xC273
#define _3DS_C_REND_TO              0xC274
#define _3DS_C_REND_NTH             0xC275
#define _3DS_C_PAL_TYPE             0xC276
#define _3DS_C_RND_TURBO            0xC277
#define _3DS_C_RND_MIP              0xC278
#define _3DS_C_BGND_METHOD          0xC279
#define _3DS_C_AUTO_REFLECT         0xC27A
#define _3DS_C_VP_FROM              0xC27B
#define _3DS_C_VP_TO                0xC27C
#define _3DS_C_VP_NTH               0xC27D
#define _3DS_C_REND_TSTEP           0xC27E
#define _3DS_C_VP_TSTEP             0xC27F
#define _3DS_C_SRDIAM               0xC280
#define _3DS_C_SRDEG                0xC290
#define _3DS_C_SRSEG                0xC2A0
#define _3DS_C_SRDIR                0xC2B0
#define _3DS_C_HETOP                0xC2C0
#define _3DS_C_HEBOT                0xC2D0
#define _3DS_C_HEHT                 0xC2E0
#define _3DS_C_HETURNS              0xC2F0
#define _3DS_C_HEDEG                0xC300
#define _3DS_C_HESEG                0xC310
#define _3DS_C_HEDIR                0xC320
#define _3DS_C_QUIKSTUFF            0xC330
#define _3DS_C_SEE_LIGHTS           0xC340
#define _3DS_C_SEE_CAMERAS          0xC350
#define _3DS_C_SEE_3D               0xC360
#define _3DS_C_MESHSEL              0xC370
#define _3DS_C_MESHUNSEL            0xC380
#define _3DS_C_POLYSEL              0xC390
#define _3DS_C_POLYUNSEL            0xC3A0
#define _3DS_C_SHPLOCAL             0xC3A2
#define _3DS_C_MSHLOCAL             0xC3A4
#define _3DS_C_NUM_FORMAT           0xC3B0
#define _3DS_C_ARCH_DENOM           0xC3C0
#define _3DS_C_IN_DEVICE            0xC3D0
#define _3DS_C_MSCALE               0xC3E0
#define _3DS_C_COMM_PORT            0xC3F0
#define _3DS_C_TAB_BASES            0xC400
#define _3DS_C_TAB_DIVS             0xC410
#define _3DS_C_MASTER_SCALES        0xC420
#define _3DS_C_SHOW_1STVERT         0xC430
#define _3DS_C_SHAPER_OK            0xC440
#define _3DS_C_LOFTER_OK            0xC450
#define _3DS_C_EDITOR_OK            0xC460
#define _3DS_C_KEYFRAMER_OK         0xC470
#define _3DS_C_PICKSIZE             0xC480
#define _3DS_C_MAPTYPE              0xC490
#define _3DS_C_MAP_DISPLAY          0xC4A0
#define _3DS_C_TILE_XY              0xC4B0
#define _3DS_C_MAP_XYZ              0xC4C0
#define _3DS_C_MAP_SCALE            0xC4D0
#define _3DS_C_MAP_MATRIX_OLD       0xC4E0
#define _3DS_C_MAP_MATRIX           0xC4E1
#define _3DS_C_MAP_WID_HT           0xC4F0
#define _3DS_C_OBNAME               0xC500
#define _3DS_C_CAMNAME              0xC510
#define _3DS_C_LTNAME               0xC520
#define _3DS_C_CUR_MNAME            0xC525
#define _3DS_C_CURMTL_FROM_MESH     0xC526
#define _3DS_C_GET_SHAPE_MAKE_FACES 0xC527
#define _3DS_C_DETAIL               0xC530
#define _3DS_C_VERTMARK             0xC540
#define _3DS_C_MSHAX                0xC550
#define _3DS_C_MSHCP                0xC560
#define _3DS_C_USERAX               0xC570
#define _3DS_C_SHOOK                0xC580
#define _3DS_C_RAX                  0xC590
#define _3DS_C_STAPE                0xC5A0
#define _3DS_C_LTAPE                0xC5B0
#define _3DS_C_ETAPE                0xC5C0
#define _3DS_C_KTAPE                0xC5C8
#define _3DS_C_ETAPE                0xC5C0
#define _3DS_C_SPHSEGS              0xC5D0
#define _3DS_C_GEOSMOOTH            0xC5E0
#define _3DS_C_HEMISEGS             0xC5F0
#define _3DS_C_PRISMSEGS            0xC600
#define _3DS_C_PRISMSIDES           0xC610
#define _3DS_C_TUBESEGS             0xC620
#define _3DS_C_TUBESIDES            0xC630
#define _3DS_C_TORSEGS              0xC640
#define _3DS_C_TORSIDES             0xC650
#define _3DS_C_CONESIDES            0xC660
#define _3DS_C_CONESEGS             0xC661
#define _3DS_C_NGPARMS              0xC670
#define _3DS_C_PTHLEVEL             0xC680
#define _3DS_C_MSCSYM               0xC690
#define _3DS_C_MFTSYM               0xC6A0
#define _3DS_C_MTTSYM               0xC6B0
#define _3DS_C_SMOOTHING            0xC6C0
#define _3DS_C_MODICOUNT            0xC6D0
#define _3DS_C_FONTSEL              0xC6E0
#define _3DS_C_TESS_TYPE            0xC6F0
#define _3DS_C_TESS_TENSION         0xC6F1
#define _3DS_C_SEG_START            0xC700
#define _3DS_C_SEG_END              0xC705
#define _3DS_C_CURTIME              0xC710
#define _3DS_C_ANIMLENGTH           0xC715
#define _3DS_C_PV_FROM              0xC720
#define _3DS_C_PV_TO                0xC725
#define _3DS_C_PV_DOFNUM            0xC730
#define _3DS_C_PV_RNG               0xC735
#define _3DS_C_PV_NTH               0xC740
#define _3DS_C_PV_TYPE              0xC745
#define _3DS_C_PV_METHOD            0xC750
#define _3DS_C_PV_FPS               0xC755
#define _3DS_C_VTR_FRAMES           0xC765
#define _3DS_C_VTR_HDTL             0xC770
#define _3DS_C_VTR_HD               0xC771
#define _3DS_C_VTR_TL               0xC772
#define _3DS_C_VTR_IN               0xC775
#define _3DS_C_VTR_PK               0xC780
#define _3DS_C_VTR_SH               0xC785
#define _3DS_C_WORK_MTLS            0xC790
#define _3DS_C_WORK_MTLS_2          0xC792
#define _3DS_C_WORK_MTLS_3          0xC793
#define _3DS_C_WORK_MTLS_4          0xC794
#define _3DS_C_BGTYPE               0xC7A1
#define _3DS_C_MEDTILE              0xC7B0
#define _3DS_C_LO_CONTRAST          0xC7D0
#define _3DS_C_HI_CONTRAST          0xC7D1
#define _3DS_C_FROZ_DISPLAY         0xC7E0
#define _3DS_C_BOOLWELD             0xC7F0
#define _3DS_C_BOOLTYPE             0xC7F1
#define _3DS_C_AND_THRESH           0xC900
#define _3DS_C_SS_THRESH            0xC901
#define _3DS_C_TEXTURE_BLUR_DEFAULT 0xC903
#define _3DS_C_MAPDRAWER            0xCA00
#define _3DS_C_MAPDRAWER1           0xCA01
#define _3DS_C_MAPDRAWER2           0xCA02
#define _3DS_C_MAPDRAWER3           0xCA03
#define _3DS_C_MAPDRAWER4           0xCA04
#define _3DS_C_MAPDRAWER5           0xCA05
#define _3DS_C_MAPDRAWER6           0xCA06
#define _3DS_C_MAPDRAWER7           0xCA07
#define _3DS_C_MAPDRAWER8           0xCA08
#define _3DS_C_MAPDRAWER9           0xCA09
#define _3DS_C_MAPDRAWER_ENTRY      0xCA10
#define _3DS_C_BACKUP_FILE          0xCA20
#define _3DS_C_DITHER_256           0xCA21
#define _3DS_C_SAVE_LAST            0xCA22
#define _3DS_C_USE_ALPHA            0xCA23
#define _3DS_C_TGA_DEPTH            0xCA24
#define _3DS_C_REND_FIELDS          0xCA25
#define _3DS_C_REFLIP               0xCA26
#define _3DS_C_SEL_ITEMTOG          0xCA27
#define _3DS_C_SEL_RESET            0xCA28
#define _3DS_C_STICKY_KEYINF        0xCA29
#define _3DS_C_WELD_THRESHOLD       0xCA2A
#define _3DS_C_ZCLIP_POINT          0xCA2B
#define _3DS_C_ALPHA_SPLIT          0xCA2C
#define _3DS_C_KF_SHOW_BACKFACE     0xCA30
#define _3DS_C_OPTIMIZE_LOFT        0xCA40
#define _3DS_C_TENS_DEFAULT         0xCA42
#define _3DS_C_CONT_DEFAULT         0xCA44
#define _3DS_C_BIAS_DEFAULT         0xCA46
#define _3DS_C_DXFNAME_SRC          0xCA50
#define _3DS_C_AUTO_WELD            0xCA60
#define _3DS_C_AUTO_UNIFY           0xCA70
#define _3DS_C_AUTO_SMOOTH          0xCA80
#define _3DS_C_DXF_SMOOTH_ANG       0xCA90
#define _3DS_C_SMOOTH_ANG           0xCAA0
#define _3DS_C_WORK_MTLS_5          0xCB00
#define _3DS_C_WORK_MTLS_6          0xCB01
#define _3DS_C_WORK_MTLS_7          0xCB02
#define _3DS_C_WORK_MTLS_8          0xCB03
#define _3DS_C_WORKMTL              0xCB04
#define _3DS_C_SXP_TEXT_DATA        0xCB10
#define _3DS_C_SXP_OPAC_DATA        0xCB11
#define _3DS_C_SXP_BUMP_DATA        0xCB12
#define _3DS_C_SXP_SHIN_DATA        0xCB13
#define _3DS_C_SXP_TEXT2_DATA       0xCB20
#define _3DS_C_SXP_SPEC_DATA        0xCB24
#define _3DS_C_SXP_SELFI_DATA       0xCB28
#define _3DS_C_SXP_TEXT_MASKDATA    0xCB30
#define _3DS_C_SXP_TEXT2_MASKDATA   0xCB32
#define _3DS_C_SXP_OPAC_MASKDATA    0xCB34
#define _3DS_C_SXP_BUMP_MASKDATA    0xCB36
#define _3DS_C_SXP_SPEC_MASKDATA    0xCB38
#define _3DS_C_SXP_SHIN_MASKDATA    0xCB3A
#define _3DS_C_SXP_REFL_MASKDATA    0xCB3E
#define _3DS_C_NET_USE_VPOST        0xCC00
#define _3DS_C_NET_USE_GAMMA        0xCC10
#define _3DS_C_NET_FIELD_ORDER      0xCC20
#define _3DS_C_BLUR_FRAMES          0xCD00
#define _3DS_C_BLUR_SAMPLES         0xCD10
#define _3DS_C_BLUR_DUR             0xCD20
#define _3DS_C_HOT_METHOD           0xCD30
#define _3DS_C_HOT_CHECK            0xCD40
#define _3DS_C_PIXEL_SIZE           0xCD50
#define _3DS_C_DISP_GAMMA           0xCD60
#define _3DS_C_FBUF_GAMMA           0xCD70
#define _3DS_C_FILE_OUT_GAMMA       0xCD80
#define _3DS_C_FILE_IN_GAMMA        0xCD82
#define _3DS_C_GAMMA_CORRECT        0xCD84
#define _3DS_C_APPLY_DISP_GAMMA     0xCD90
#define _3DS_C_APPLY_FBUF_GAMMA     0xCDA0
#define _3DS_C_APPLY_FILE_GAMMA     0xCDB0
#define _3DS_C_FORCE_WIRE           0xCDC0
#define _3DS_C_RAY_SHADOWS          0xCDD0
#define _3DS_C_MASTER_AMBIENT       0xCDE0
#define _3DS_C_SUPER_SAMPLE         0xCDF0
#define _3DS_C_OBJECT_MBUR          0xCE00
#define _3DS_C_MBLUR_DITHER         0xCE10
#define _3DS_C_DITHER_24            0xCE20
#define _3DS_C_SUPER_BLACK          0xCE30
#define _3DS_C_SAFE_FRAME           0xCE40
#define _3DS_C_VIEW_PRES_RATIO      0xCE50
#define _3DS_C_BGND_PRES_RATIO      0xCE60
#define _3DS_C_NTH_SERIAL_NUM       0xCE70
#define _3DS_VPDATA                 0xD000
#define _3DS_P_QUEUE_ENTRY          0xD100
#define _3DS_P_QUEUE_IMAGE          0xD110
#define _3DS_P_QUEUE_USEIGAMMA      0xD114
#define _3DS_P_QUEUE_PROC           0xD120
#define _3DS_P_QUEUE_SOLID          0xD130
#define _3DS_P_QUEUE_GRADIENT       0xD140
#define _3DS_P_QUEUE_KF             0xD150
#define _3DS_P_QUEUE_MOTBLUR        0xD152
#define _3DS_P_QUEUE_MB_REPEAT      0xD153
#define _3DS_P_QUEUE_NONE           0xD160
#define _3DS_P_QUEUE_RESIZE         0xD180
#define _3DS_P_QUEUE_OFFSET         0xD185
#define _3DS_P_QUEUE_ALIGN          0xD190
#define _3DS_P_CUSTOM_SIZE          0xD1A0
#define _3DS_P_ALPH_NONE            0xD210
#define _3DS_P_ALPH_PSEUDO          0xD220
#define _3DS_P_ALPH_OP_PSEUDO       0xD221
#define _3DS_P_ALPH_BLUR            0xD222
#define _3DS_P_ALPH_PCOL            0xD225
#define _3DS_P_ALPH_CO              0xD230
#define _3DS_P_ALPH_OP_KEY          0xD231
#define _3DS_P_ALPH_KCOL            0xD235
#define _3DS_P_ALPH_OP_NOCONV       0xD238
#define _3DS_P_ALPH_IMAGE           0xD240
#define _3DS_P_ALPH_ALPHA           0xD250
#define _3DS_P_ALPH_QUES            0xD260
#define _3DS_P_ALPH_QUEIMG          0xD265
#define _3DS_P_ALPH_CUTOFF          0xD270
#define _3DS_P_ALPHANEG             0xD280
#define _3DS_P_TRAN_NONE            0xD300
#define _3DS_P_TRAN_IMAGE           0xD310
#define _3DS_P_TRAN_FRAMES          0xD312
#define _3DS_P_TRAN_FADEIN          0xD320
#define _3DS_P_TRAN_FADEOUT         0xD330
#define _3DS_P_TRANNEG              0xD340
#define _3DS_P_RANGES               0xD400
#define _3DS_P_PROC_DATA            0xD500
#define _3DS_POS_TRACK_TAG_KEY      0xF020
#define _3DS_ROT_TRACK_TAG_KEY      0xF021
#define _3DS_SCL_TRACK_TAG_KEY      0xF022
#define _3DS_FOV_TRACK_TAG_KEY      0xF023
#define _3DS_ROLL_TRACK_TAG_KEY     0xF024
#define _3DS_COL_TRACK_TAG_KEY      0xF025
#define _3DS_MORPH_TRACK_TAG_KEY    0xF026
#define _3DS_HOT_TRACK_TAG_KEY      0xF027
#define _3DS_FALL_TRACK_TAG_KEY     0xF028
#define _3DS_POINT_ARRAY_ENTRY      0xF110
#define _3DS_POINT_FLAG_ARRAY_ENTRY 0xF120
#define _3DS_FACE_ARRAY_ENTRY       0xF130
#define _3DS_TEX_VERTS_ENTRY        0xF140
#define _3DS_SMOOTH_GROUP_ENTRY     0xF150
#define _3DS_DUMMY                  0xFFFF
