#define _CRT_SECURE_NO_DEPRECATE
#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#define _USE_MATH_DEFINES
#include <math.h>
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include "..\\utilities\\model.h"
#include "..\\utilities\\colors.h"

struct{int*index,m,n;}poly;
struct{DWORD*rgb;int m,n;}matl;
typedef struct{double X,Y,Z;}XYZ;
struct{XYZ*xyz;int m,n;}node;

static MODEL model;

void AddWRL(int i,int j,int k,DWORD rgb)
  {
  XYZ p,q,r;
  p=node.xyz[poly.index[i]];
  q=node.xyz[poly.index[j]];
  r=node.xyz[poly.index[k]];
  MoreNodes(&model,3);
  MoreElems(&model,1);
  model.node[model.nodes].x=(float)p.X;
  model.node[model.nodes].y=(float)p.Y;
  model.node[model.nodes].z=(float)p.Z;
  model.elem[model.elems].i=model.nodes++;
  model.node[model.nodes].x=(float)r.X;
  model.node[model.nodes].y=(float)r.Y;
  model.node[model.nodes].z=(float)r.Z;
  model.elem[model.elems].j=model.nodes++;
  model.node[model.nodes].x=(float)q.X;
  model.node[model.nodes].y=(float)q.Y;
  model.node[model.nodes].z=(float)q.Z;
  model.elem[model.elems].k=model.nodes++;
  model.elem[model.elems].m=-1;
  model.elem[model.elems++].color=rgb;
  }

char*GetWRL(char*bufr,FILE*fp)
  {
  int i,l=0;
  while(1)
    {
    i=fgetc(fp);
    if(i==EOF)
      {
      if(l)
        {
        bufr[l]=0;
        return(bufr);
        }
      else
        return(NULL);
      }
    else if(i<=' '||i==',')
      {
      if(l)
        {
        bufr[l]=0;
        return(bufr);
        }
      }
    else if(strchr("{[]}",i))
      {
      if(l)
        {
        ungetc(i,fp);
        bufr[l]=0;
        return(bufr);
        }
      else
        {
        bufr[0]=i;
        bufr[1]=0;
        return(bufr);
        }
      }
    else
      bufr[l++]=i;
    }
  }

MODEL ReadWRL(char*fname)
  {
  char bufr[128],*ptr;
  int ccw=TRUE,MaterialBinding=FALSE;
  int b,g,i,j,m,n,r;
  double B,G,R,X,Y,Z;
  FILE*fp;
  memset(&model,0,sizeof(MODEL));
  if((fp=fopen(fname,"rt"))==NULL)
    {
    MessageBox(NULL,"can't open input file",fname,MB_ICONSTOP|MB_OK);
    return(model);
    }
  matl.m=100;
  matl.n=0;
  matl.rgb=allocate(__LINE__,matl.m,sizeof(DWORD));
  matl.rgb[0]=0xFF0000;
  node.m=1000;
  node.n=0;
  node.xyz=allocate(__LINE__,node.m,sizeof(XYZ));
  poly.m=1000;
  poly.n=0;
  poly.index=allocate(__LINE__,poly.m,sizeof(int));
  while((ptr=GetWRL(bufr,fp))!=NULL)
    {
    if(!_stricmp(ptr,"ccw"))
      {
      if((ptr=GetWRL(bufr,fp))==NULL)
        {
        MessageBox(NULL,"unexpected end of file","EOF error",MB_ICONSTOP|MB_OK);
        memset(&model,0,sizeof(MODEL));
        return(model);
        }
      if(!_stricmp(ptr,"FALSE"))
        ccw=FALSE;
      else if(!_stricmp(ptr,"TRUE"))
        ccw=TRUE;
      else if(_stricmp(ptr,"UNKNOWN"))
        {
        MessageBox(NULL,"unexpected element orientation","model",MB_ICONSTOP|MB_OK);
        memset(&model,0,sizeof(MODEL));
        return(model);
        }
      }
    else if(!_stricmp(ptr,"colorIndex"))
      {
      MessageBox(NULL,"can't handle colorIndex","compatibility error",MB_ICONSTOP|MB_OK);
      memset(&model,0,sizeof(MODEL));
      return(model);
      }
    else if(!_stricmp(ptr,"coordIndex"))
      {
      if(node.n==0)
        {
        MessageBox(NULL,"points expected before coordIndex","model error",MB_ICONSTOP|MB_OK);
        memset(&model,0,sizeof(MODEL));
        return(model);
        }
      if((ptr=GetWRL(bufr,fp))==NULL)
        {
        MessageBox(NULL,"unexpected end of file","EOF error",MB_ICONSTOP|MB_OK);
        memset(&model,0,sizeof(MODEL));
        return(model);
        }
      if(strcmp(ptr,"\x5B"))
        {
        MessageBox(NULL,"expected \x5B to follow coordIndex","model error",MB_ICONSTOP|MB_OK);
        memset(&model,0,sizeof(MODEL));
        return(model);
        }
      poly.n=0;
      while(1)
        {
        if((ptr=GetWRL(bufr,fp))==NULL)
          {
          MessageBox(NULL,"unexpected end of file","EOF error",MB_ICONSTOP|MB_OK);
          memset(&model,0,sizeof(MODEL));
          return(model);
          }
        if(!strcmp(ptr,"\x5D"))
          break;
        if(sscanf(ptr,"%li",&n)!=1)
          {
          MessageBox(NULL,"can't read model","scan error",MB_ICONSTOP|MB_OK);
          memset(&model,0,sizeof(MODEL));
          return(model);
          }
        if(n>=node.n)
          {
          MessageBox(NULL,"no such point","model error",MB_ICONSTOP|MB_OK);
          memset(&model,0,sizeof(MODEL));
          return(model);
          }
        if(poly.n>=poly.m)
          {
          poly.m+=1000;
          poly.index=reallocate(__LINE__,poly.index,poly.n,poly.m,sizeof(int));
          }
        poly.index[poly.n++]=n;
        }
      if(MaterialBinding)
        continue;
      i=0;
      while(i<poly.n)
        {
        n=0;
        while(poly.index[i+n]>=0)
          n++;
        if(ccw)
          for(j=2;j<n;j++)
            AddWRL(i,i+j,i+j-1,matl.rgb[0]);
        else
          for(j=2;j<n;j++)
            AddWRL(i,i+j-1,i+j,matl.rgb[0]);
        i+=n+1;
        }
      poly.n=0;
      }
    else if(!_stricmp(ptr,"diffuseColor"))
      {
      if((ptr=GetWRL(bufr,fp))==NULL)
        {
        MessageBox(NULL,"unexpected end of file","EOF error",MB_ICONSTOP|MB_OK);
        memset(&model,0,sizeof(MODEL));
        return(model);
        }
      matl.n=n=0;
      matl.rgb[0]=0xFF0000;
      if(strcmp(ptr,"\x5B"))
        n=1;
      while(1)
        {
        if(n==0)
          {
          if((ptr=GetWRL(bufr,fp))==NULL)
            {
            MessageBox(NULL,"unexpected end of file","EOF error",MB_ICONSTOP|MB_OK);
            memset(&model,0,sizeof(MODEL));
            return(model);
            }
          if(!strcmp(ptr,"\x5D"))
            break;
          }
        if(sscanf(ptr,"%lf",&R)!=1)
          {
          MessageBox(NULL,"can't read model","scan error",MB_ICONSTOP|MB_OK);
          memset(&model,0,sizeof(MODEL));
          return(model);
          }
        if((ptr=GetWRL(bufr,fp))==NULL)
          {
          MessageBox(NULL,"unexpected end of file","EOF error",MB_ICONSTOP|MB_OK);
          memset(&model,0,sizeof(MODEL));
          return(model);
          }
        if(sscanf(ptr,"%lf",&G)!=1)
          {
          MessageBox(NULL,"can't read model","scan error",MB_ICONSTOP|MB_OK);
          memset(&model,0,sizeof(MODEL));
          return(model);
          }
        if((ptr=GetWRL(bufr,fp))==NULL)
          {
          MessageBox(NULL,"unexpected end of file","EOF error",MB_ICONSTOP|MB_OK);
          memset(&model,0,sizeof(MODEL));
          return(model);
          }
        if(sscanf(ptr,"%lf",&B)!=1)
          {
          MessageBox(NULL,"can't read model","scan error",MB_ICONSTOP|MB_OK);
          memset(&model,0,sizeof(MODEL));
          return(model);
          }
        if(matl.n>=matl.m)
          {
          matl.m+=100;
          matl.rgb=reallocate(__LINE__,matl.rgb,matl.n,matl.m,sizeof(DWORD));
          }
        r=(BYTE)max(0,min(255,255*R));
        g=(BYTE)max(0,min(255,255*G));
        b=(BYTE)max(0,min(255,255*B));
        matl.rgb[matl.n++]=RGB(b,g,r);
        if(n!=0)
          break;
        }
      }
    else if(!_stricmp(ptr,"MaterialBinding"))
      {
      if((ptr=GetWRL(bufr,fp))==NULL)
        {
        MessageBox(NULL,"unexpected end of file","EOF error",MB_ICONSTOP|MB_OK);
        memset(&model,0,sizeof(MODEL));
        return(model);
        }
      if(strcmp(ptr,"\x7B"))
        {
        MessageBox(NULL,"expected \x7B to follow MaterialBinding","model error",MB_ICONSTOP|MB_OK);
        memset(&model,0,sizeof(MODEL));
        return(model);
        }
      if((ptr=GetWRL(bufr,fp))==NULL)
        {
        MessageBox(NULL,"unexpected end of file","EOF error",MB_ICONSTOP|MB_OK);
        memset(&model,0,sizeof(MODEL));
        return(model);
        }
      if(_stricmp(ptr,"value"))
        {
        MessageBox(NULL,"expected value to follow MaterialBinding","model error",MB_ICONSTOP|MB_OK);
        memset(&model,0,sizeof(MODEL));
        return(model);
        }
      if((ptr=GetWRL(bufr,fp))==NULL)
        {
        MessageBox(NULL,"unexpected end of file","EOF error",MB_ICONSTOP|MB_OK);
        memset(&model,0,sizeof(MODEL));
        return(model);
        }
      if(!_stricmp(ptr,"OVERALL"))
        MaterialBinding=FALSE;
      else if(stristr(ptr,"PER_FACE_INDEXED"))
        MaterialBinding=TRUE;
      else if(!_stricmp(ptr,"PER_FACE"))
        MaterialBinding=TRUE;
      else
        {
        MessageBox(NULL,"unexpected MaterialBinding option","model error",MB_ICONSTOP|MB_OK);
        memset(&model,0,sizeof(MODEL));
        return(model);
        }
      if((ptr=GetWRL(bufr,fp))==NULL)
        {
        MessageBox(NULL,"unexpected end of file","EOF error",MB_ICONSTOP|MB_OK);
        memset(&model,0,sizeof(MODEL));
        return(model);
        }
      if(strcmp(ptr,"\x7D"))
        {
        MessageBox(NULL,"expected \x7D to follow MaterialBinding","model error",MB_ICONSTOP|MB_OK);
        memset(&model,0,sizeof(MODEL));
        return(model);
        }
      }
    else if(!_stricmp(ptr,"materialIndex"))
      {
      if(poly.n==0)
        {
        MessageBox(NULL,"cooddIndex expected before materialIndex","model error",MB_ICONSTOP|MB_OK);
        memset(&model,0,sizeof(MODEL));
        return(model);
        }
      if((ptr=GetWRL(bufr,fp))==NULL)
        {
        MessageBox(NULL,"unexpected end of file","EOF error",MB_ICONSTOP|MB_OK);
        memset(&model,0,sizeof(MODEL));
        return(model);
        }
      if(strcmp(ptr,"\x5B"))
        {
        MessageBox(NULL,"expected \x5B to follow materialIndex","model error",MB_ICONSTOP|MB_OK);
        memset(&model,0,sizeof(MODEL));
        return(model);
        }
      i=0;
      while(1)
        {
        if((ptr=GetWRL(bufr,fp))==NULL)
          {
          MessageBox(NULL,"unexpected end of file","EOF error",MB_ICONSTOP|MB_OK);
          memset(&model,0,sizeof(MODEL));
          return(model);
          }
        if(!strcmp(ptr,"\x5D"))
          break;
        if(sscanf(ptr,"%li",&m)!=1)
          {
          MessageBox(NULL,"can't read model","scan error",MB_ICONSTOP|MB_OK);
          memset(&model,0,sizeof(MODEL));
          return(model);
          }
        if(m<0||m>=matl.n)
          {
          MessageBox(NULL,"no such material","model error",MB_ICONSTOP|MB_OK);
          memset(&model,0,sizeof(MODEL));
          return(model);
          }
        if(i>=poly.n)
          {
          MessageBox(NULL,"more material indices than coordIndex groups","model error",MB_ICONSTOP|MB_OK);
          memset(&model,0,sizeof(MODEL));
          return(model);
          }
        n=0;
        while(poly.index[i+n]>=0)
          n++;
        if(ccw)
          for(j=2;j<n;j++)
            AddWRL(i,i+j,i+j-1,matl.rgb[0]);
        else
          for(j=2;j<n;j++)
            AddWRL(i,i+j-1,i+j,matl.rgb[0]);
        i+=n+1;
        }
      if(i<poly.n)
        {
        MessageBox(NULL,"fewer material indices than coordIndex groups","model error",MB_ICONSTOP|MB_OK);
        memset(&model,0,sizeof(MODEL));
        return(model);
        }
      poly.n=0;
      }
    else if(!_stricmp(ptr,"point"))
      {
      if((ptr=GetWRL(bufr,fp))==NULL)
        {
        MessageBox(NULL,"unexpected end of file","EOF error",MB_ICONSTOP|MB_OK);
        memset(&model,0,sizeof(MODEL));
        return(model);
        }
      if(strcmp(ptr,"\x5B"))
        {
        MessageBox(NULL,"expected \x5B to follow point","model error",MB_ICONSTOP|MB_OK);
        memset(&model,0,sizeof(MODEL));
        return(model);
        }
      node.n=0;
      while(1)
        {
        if((ptr=GetWRL(bufr,fp))==NULL)
          {
          MessageBox(NULL,"unexpected end of file","EOF error",MB_ICONSTOP|MB_OK);
          memset(&model,0,sizeof(MODEL));
          return(model);
          }
        if(!strcmp(ptr,"\x5D"))
          break;
        if(sscanf(ptr,"%lf",&X)!=1)
          {
          MessageBox(NULL,"can't read model","scan error",MB_ICONSTOP|MB_OK);
          memset(&model,0,sizeof(MODEL));
          return(model);
          }
        if((ptr=GetWRL(bufr,fp))==NULL)
          {
          MessageBox(NULL,"unexpected end of file","EOF error",MB_ICONSTOP|MB_OK);
          memset(&model,0,sizeof(MODEL));
          return(model);
          }
        if(sscanf(ptr,"%lf",&Y)!=1)
          {
          MessageBox(NULL,"can't read model","scan error",MB_ICONSTOP|MB_OK);
          memset(&model,0,sizeof(MODEL));
          return(model);
          }
        if((ptr=GetWRL(bufr,fp))==NULL)
          {
          MessageBox(NULL,"unexpected end of file","EOF error",MB_ICONSTOP|MB_OK);
          memset(&model,0,sizeof(MODEL));
          return(model);
          }
        if(sscanf(ptr,"%lf",&Z)!=1)
          {
          MessageBox(NULL,"can't read model","scan error",MB_ICONSTOP|MB_OK);
          memset(&model,0,sizeof(MODEL));
          return(model);
          }
        if(node.n>=node.m)
          {
          node.m+=1000;
          node.xyz=reallocate(__LINE__,node.xyz,node.n,node.m,sizeof(XYZ));
          }
        node.xyz[node.n].X=X;
        node.xyz[node.n].Y=Y;
        node.xyz[node.n].Z=Z;
        node.n++;
        }
      }
    else if(!_stricmp(ptr,"vertexOrdering"))
      {
      if((ptr=GetWRL(bufr,fp))==NULL)
        {
        MessageBox(NULL,"unexpected end of file","EOF error",MB_ICONSTOP|MB_OK);
        memset(&model,0,sizeof(MODEL));
        return(model);
        }
      if(!_stricmp(ptr,"CLOCKWISE"))
        ccw=FALSE;
      else if(!_stricmp(ptr,"COUNTERCLOCKWISE"))
        ccw=TRUE;
      else if(_stricmp(ptr,"UNKNOWN_ORDERING"))
        {
        MessageBox(NULL,"unexpected vertex ordering","model error",MB_ICONSTOP|MB_OK);
        memset(&model,0,sizeof(MODEL));
        return(model);
        }
      }
    }
  fclose(fp);
  free(poly.index);
  free(matl.rgb);
  free(node.xyz);
  return(model);
  }

struct{DWORD m,n,*i;}clr;

void insertC(DWORD c)
  {
  int i,j,j1,j2;
  if(clr.m==0)
    {
    clr.m=10;
    clr.i=calloc(clr.m,sizeof(DWORD));
    clr.i[0]=c;
    clr.n=1;
    return;
    }
  j1=0;
  j2=clr.n;
  for(i=0;i<32;i++)
    {
    j=(j1+j2)/2;
    if(clr.i[i]==c)
      return;
    if(j1==j)
      {
      if(clr.i[j]<c)
        j++;
      break;
      }
    else if(clr.i[j]<c)
      j1=j;
    else if(clr.i[j]>c)
      j2=j;
    }
  if(clr.n>=clr.m)
    {
    DWORD*k;
    k=clr.i;
    clr.m+=10;
    clr.i=calloc(clr.m,sizeof(DWORD));
    memcpy(clr.i,k,clr.n*sizeof(DWORD));
    free(k);
    }
  if(j<(int)clr.n)
    memmove(clr.i+j+1,clr.i+j,(clr.n-j)*sizeof(DWORD));
  clr.i[j]=c;
  clr.n++;
  }

void WriteWRL(MODEL*m0del,char*fname)
  {
  BYTE b,g,r;
  DWORD rgb;
  int i,j;
  FILE*fp;
  if((fp=fopen(fname,"wt"))==NULL)
    {
    MessageBox(NULL,"can't create output file",fname,MB_ICONSTOP|MB_OK);
    return;
    }
  for(i=0;i<m0del->elems;i++)
    {
    if(m0del->elem[i].m>=0)
      m0del->elem[i].color=white;
    insertC(m0del->elem[i].color);
    }
  fprintf(fp,"#VRML V1.0 ascii\n");
  fprintf(fp,"Separator\n");
  fprintf(fp," \x7B\n");
  fprintf(fp," MaterialBinding\n");
  fprintf(fp,"  \x7B\n");
  fprintf(fp,"  value PER_FACE_INDEXED\n");
  fprintf(fp,"  \x7D\n");
  fprintf(fp," Material\n");
  fprintf(fp,"  \x7B\n");
  fprintf(fp,"  diffuseColor\x5B\n");
  for(i=0;i<(int)clr.n;i++)
    {
    rgb=clr.i[i];
    r=(BYTE)((rgb&0xFF0000)>>16);
    g=(BYTE)((rgb&0x00FF00)>> 8);
    b=(BYTE) (rgb&0x0000FF)     ;
    fprintf(fp," %lf %lf %lf,\n",r/255.,g/255.,b/255.);
    }
  fprintf(fp,"  \x5D\x7D\n");
  fprintf(fp," Coordinate3\n");
  fprintf(fp,"  \x7B\n");
  fprintf(fp,"  point\x5B\n");
  for(i=0;i<m0del->nodes;i++)
    fprintf(fp,"  %hG %hG %hG,\n",m0del->node[i].x,m0del->node[i].y,m0del->node[i].z);
  fprintf(fp,"  \x5D\x7D\n");
  fprintf(fp," ShapeHints\n");
  fprintf(fp,"  \x7B\n");
  fprintf(fp,"  vertexOrdering COUNTERCLOCKWISE\n");
  fprintf(fp,"  \x7D\n");
  fprintf(fp," IndexedFaceSet\n");
  fprintf(fp,"  \x7B\n");
  fprintf(fp,"  coordIndex\x5B\n");
  for(i=0;i<m0del->elems;i++)
    fprintf(fp," %i,%i,%i,-1,\n ",m0del->elem[i].i,m0del->elem[i].j,m0del->elem[i].k);
  fprintf(fp,"  \x5D\n");
  fprintf(fp,"  materialIndex\x5B");
  for(i=0;i<m0del->elems;i++)
    {
    for(j=0;j<(int)clr.n;j++)
      if(m0del->elem[i].color==clr.i[j])
        break;
    fprintf(fp," %i,\n",j);
    }
  fprintf(fp," \x5D\x7D\n");
  fprintf(fp," \x7D\n");
  fclose(fp);
  free(clr.i);
  memset(&clr,0,sizeof(clr));
  }
